examples.jmarkov

## Class PickBlockWideSlow

- java.lang.Object
- - jmarkov.MarkovProcess<S,E>
  - - jmarkov.SimpleMarkovProcess<examples.jmarkov.PickBlockWideSlowState,examples.jmarkov.PickBlockWideSlowEvent>
    - - examples.jmarkov.PickBlockWideSlow

- All Implemented Interfaces:
    JMarkovElement

      public class PickBlockWideSlow
      extends SimpleMarkovProcess<examples.jmarkov.PickBlockWideSlowState,examples.jmarkov.PickBlockWideSlowEvent>

  This class represents a Wide Aisle Picking System with 2 pickers n picklocs and a 1:1 pick/walk speed ratio. Each picker picks at a given location with probability p, o walks by with probability q=1-p The pickers are blocked when one reaches the other and is unable to pick because he is picking. We assume a circular warehouse without time spent at the I/O point.
  Author:
    Daniel F. Silva (2007)

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class jmarkov.MarkovProcess

      `MarkovProcess.Status`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PickBlockWideSlow()` Default Constructor used by GUI
    `PickBlockWideSlow(double p, int picklocs, int[] a)` General constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `active(examples.jmarkov.PickBlockWideSlowState i, examples.jmarkov.PickBlockWideSlowEvent e)` Determine the active events.
    `java.lang.String` | `description()` This method should be implemented by the subclass to give word description of the model.
    `States<examples.jmarkov.PickBlockWideSlowState>` | `dests(examples.jmarkov.PickBlockWideSlowState i, examples.jmarkov.PickBlockWideSlowEvent e)` Determines the destination set of States when events e occurs.
    `int` | `getPicklocs()`
    `double` | `getProbability()`
    `double` | `getProbs(int[] i, int[] j)`
    `static void` | `main(java.lang.String[] a)` Main method.
    `int` | `printMOPs(java.io.PrintWriter out, int width, int decimals)` Replaces the method to print MOPs.
    `double` | `rate(examples.jmarkov.PickBlockWideSlowState i, examples.jmarkov.PickBlockWideSlowState j, examples.jmarkov.PickBlockWideSlowEvent e)` Returns the transition probability from State i to State j.

    - ### Methods inherited from class jmarkov.SimpleMarkovProcess

      `activeTransitions`

    - ### Methods inherited from class jmarkov.MarkovProcess

      `addMOP, allToString, canGo, clearMOPs, debug, debug, debug, denseMatrixToString, denseMatrixToString, eventRatesToString, eventsRatesToString, generate, getDebugLevel, getDebugReporter, getEventClass, getEventNames, getEventRate, getEvents, getEventsRates, getFinalRate, getGenerator, getMaxStates, getMOPIndex, getMOPNames, getMOPNames, getMOPsAvg, getMOPsAvg, getMOPsAvg, getMOPsMoment, getMOPsMoment, getMOPsMoment, getMtjGenerator, getMtjRates, getNumStates, getProgress, getRate, getRates, getRates, getStateClass, getStates, getStates, getStatus, getStatusMsg, getSteadyState, getSteadyStateSolver, getTransientSolver, go, goStep, hideGUI, isGenerated, killGUI, label, loadGUI, MOPsToString, MOPsToString, numMOPs, pause, printAll, printAll, printDenseMatrix, printDenseMatrix, printEventsRates, printEventsRates, printMOPs, printMOPs, printStates, printStates, reset, resetResults, setDebugLevel, setDebugReporter, setMaxStates, setMOPs, setSteadyStateSolver, setTransientSolver, showGUI, statesLableMaxWidth, statesToString, toString`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jmarkov.basic.JMarkovElement

      `equals`

- - ### Constructor Detail

    - #### PickBlockWideSlow

          public PickBlockWideSlow(double p,
                           int picklocs,
                           int[] a)

      General constructor.
      Parameters:
        `p` - Pick Probability.
        `picklocs` - Number of Pick Locations

    - #### PickBlockWideSlow

          public PickBlockWideSlow()

      Default Constructor used by GUI

  - ### Method Detail

    - #### active

          public boolean active(examples.jmarkov.PickBlockWideSlowState i,
                       examples.jmarkov.PickBlockWideSlowEvent e)

      Determine the active events.
      Specified by:
        `active` in class `SimpleMarkovProcess<examples.jmarkov.PickBlockWideSlowState,examples.jmarkov.PickBlockWideSlowEvent>`
      Parameters:
        `i` - The current State
        `e` - The current Event.
      Returns:
        True if the Event is Active.

    - #### dests

          public States<examples.jmarkov.PickBlockWideSlowState> dests(examples.jmarkov.PickBlockWideSlowState i,
                                                              examples.jmarkov.PickBlockWideSlowEvent e)

      Description copied from class: `SimpleMarkovProcess`
      Determines the destination set of States when events e occurs. It has to be implemented by the subclass.
      Specified by:
        `dests` in class `SimpleMarkovProcess<examples.jmarkov.PickBlockWideSlowState,examples.jmarkov.PickBlockWideSlowEvent>`
      Parameters:
        `i` - current State.
        `e` - The Event that ocurred.
      Returns:
        The destination States

    - #### rate

          public double rate(examples.jmarkov.PickBlockWideSlowState i,
                    examples.jmarkov.PickBlockWideSlowState j,
                    examples.jmarkov.PickBlockWideSlowEvent e)

      Returns the transition probability from State i to State j.
      Specified by:
        `rate` in class `SimpleMarkovProcess<examples.jmarkov.PickBlockWideSlowState,examples.jmarkov.PickBlockWideSlowEvent>`
      Parameters:
        `i` - Current state
        `j` - Destination State
        `e` - The occuring event
      Returns:
        The rate at which the system goes from i to j when e occurs.
      See Also:
        `SimpleMarkovProcess.dests(State, Event)`

    - #### getProbs

          public double getProbs(int[] i,
                        int[] j)

    - #### description

          public java.lang.String description()

      Description copied from class: `MarkovProcess`
      This method should be implemented by the subclass to give word description of the model. For example it should say: Queueing system with 2 servers and exponential arrivals with rate 50 per hour.
      Specified by:
        `description` in interface `JMarkovElement`
      Specified by:
        `description` in class `MarkovProcess<examples.jmarkov.PickBlockWideSlowState,examples.jmarkov.PickBlockWideSlowEvent>`
      Returns:
        A description of the Model
      See Also:
        `JMarkovElement.label()`

    - #### printMOPs

          public int printMOPs(java.io.PrintWriter out,
                      int width,
                      int decimals)

      Replaces the method to print MOPs. This method is called in `toString()`, which is also used in the MOP's tab in the GUI.
      Overrides:
        `printMOPs` in class `MarkovProcess<examples.jmarkov.PickBlockWideSlowState,examples.jmarkov.PickBlockWideSlowEvent>`
      Parameters:
        `out` - The printer where the MOPS will be printed.
        `width` - the columns width
        `decimals` - the number of decimals to use.
      Returns:
        The max width among the declared MOPs. You can use this to align nicely your own MOPs.
      See Also:
        `MarkovProcess.printMOPs(PrintWriter)`, `MarkovProcess.printMOPs(PrintWriter, int, int)`

    - #### main

          public static void main(java.lang.String[] a)

      Main method.
      Parameters:
        `a` - Not used.

    - #### getProbability

          public double getProbability()

      Returns:
        Returns the probability.

    - #### getPicklocs

          public int getPicklocs()

      Returns:
        Returns the number of pick locations.